image: python:3.10

# Change pip's cache directory to be inside the project directory since we can
# only cache local items.
variables:
  PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"

default:
  cache:
    paths:
      - .cache/pip
      - .venv/

  before_script:
    - pip install poetry
    - poetry config virtualenvs.in-project true
    - poetry install
    - source `poetry env info --path`/bin/activate

flake8:
  script:
    - flake8p whoson

mypy:
  script:
    - mypy whoson

black:
  script:
    - black --check whoson

pytest:
  script:
    - pytest --junitxml=report.xml --cov=whoson --cov-report xml --cov-report term
  coverage: '/(?i)total.*? (100(?:\.0+)?\%|[1-9]?\d(?:\.\d+)?\%)$/'
  artifacts:
    when: always
    reports:
      junit: report.xml
      coverage_report:
        coverage_format: cobertura
        path: coverage.xml

deploy_prod:
  inherit:
    default: false  # this job won't inherit any `default:` keys
  variables:
    GIT_STRATEGY: none
  stage: deploy
  tags:
    - prod
  script:
    - cd /data/whoson
    - git fetch
    - git checkout main
    - git pull
    - poetry install
    - sudo systemctl restart whoson
  environment:
    name: Production
    url: https://whoson.knickj.com
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
